//
// https://www.ramecera.it/myscrewdriver.html
// e-mail: screwdriver@ramecera.it
//
/* This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License v1.0 which accompanies this
 * distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html */
package it.ramecera.salad.everyday;

/**
 * <p>
 * List of ISO 3166-1 standard country codes.
 * </p>
 * <p>
 * Creation date: 2020-04-09<br>
 * Last updated: 2020-04-09
 * </p>
 * 
 * @author M. Maglioni */
public class Universal {

	/** list */
	public final static String[] charsetE = { "UTF-8", "ISO-8859-1",
			"UTF-16" };
	/** list */
	public final static String[] countryCodeE = { "ax", "af", "al",
			"dz", "as", "ad", "ao", "ai", "aq", "ag", "ar", "am", "aw",
			"au", "at", "az", "bs", "bh", "bd", "bb", "by", "be", "bz",
			"bj", "bm", "bt", "bo", "ba", "bw", "bv", "br", "io", "bn",
			"bg", "bf", "bi", "kh", "cm", "ca", "cv", "ky", "cf", "td",
			"cl", "cn", "cx", "cc", "co", "km", "cd", "cg", "ck", "cr",
			"ci", "hr", "cu", "cy", "cz", "dk", "dj", "dm", "do", "ec",
			"eg", "sv", "gq", "er", "ee", "et", "fk", "fo", "fj", "fi",
			"fr", "gf", "pf", "tf", "ga", "gm", "ge", "de", "gh", "gi",
			"gr", "gl", "gd", "gp", "gu", "gt", "gn", "gw", "gy", "ht",
			"hm", "hn", "hk", "hu", "is", "in", "id", "ir", "iq", "ie",
			"il", "it", "jm", "jp", "jo", "kz", "ke", "ki", "kp", "kr",
			"kw", "kg", "la", "lv", "lb", "ls", "lr", "ly", "li", "lt",
			"lu", "mo", "mk", "mg", "mw", "my", "mv", "ml", "mt", "mh",
			"mq", "mr", "mu", "yt", "mx", "fm", "md", "mc", "mn", "ms",
			"ma", "mz", "mm", "na", "nr", "np", "nl", "an", "nc", "nz",
			"ni", "ne", "ng", "nu", "nf", "mp", "no", "om", "pk", "pw",
			"ps", "pa", "pg", "py", "pe", "ph", "pn", "pl", "pt", "pr",
			"qa", "re", "ro", "ru", "rw", "sh", "kn", "lc", "pm", "vc",
			"ws", "sm", "st", "sa", "sn", "cs", "sc", "sl", "sg", "sk",
			"si", "sb", "so", "za", "gs", "es", "lk", "sd", "sr", "sj",
			"sz", "se", "ch", "sy", "tw", "tj", "tz", "th", "tl", "tg",
			"tk", "to", "tt", "tn", "tr", "tm", "tc", "tv", "ug", "ua",
			"ae", "gb", "us", "um", "uy", "uz", "vu", "va", "ve", "vn",
			"vg", "vi", "wf", "eh", "ye", "zm", "zw" };
	/** list */
	public final static String[][] languageE = { { "Abkhazian", "AB" },
			{ "Afar", "AA" }, { "Afrikaans", "AF" }, { "Albanian",
					"SQ" }, { "Amharic", "AM" }, { "Arabic", "AR" }, {
							"Armenian", "HY" }, { "Assamese", "AS" }, {
									"Aymara", "AY" }, { "Azerbaijani",
											"AZ" }, { "Bashkir", "BA" },
			{ "Basque", "EU" }, { "Bengali,Bangla", "BN" }, { "Bhutani",
					"DZ,Bangla" }, { "Bihari", "BH" }, { "Bislama",
							"BI" }, { "Breton", "BR" }, { "Bulgarian",
									"BG" }, { "Burmese", "MY" }, {
											"Byelorussian", "BE" }, {
													"Cambodian", "KM" },
			{ "Catalan", "CA" }, { "Chinese", "ZH" }, { "Corsican",
					"CO" }, { "Croatian", "HR,American" }, { "Czech",
							"CS" }, { "Danish", "DA" }, { "Dutch",
									"NL" }, { "English,American",
											"EN" }, { "Esperanto",
													"EO" }, {
															"Estonian",
															"ET" }, {
																	"Faeroese",
																	"FO" },
			{ "Fiji", "FJ" }, { "Finnish", "FI" }, { "French", "FR" }, {
					"Frisian", "FY" }, { "Gaelic (ScotsGaelic)", "GD" },
			{ "Galician", "GL" }, { "Georgian", "KA" }, { "German",
					"DE" }, { "Greek", "EL" }, { "Greenlandic", "KL" },
			{ "Guarani", "GN" }, { "Gujarati", "GU" }, { "Hausa",
					"HA" }, { "Hebrew", "IW" }, { "Hindi", "HI" }, {
							"Hungarian", "HU" }, { "Icelandic", "IS" },
			{ "Indonesian", "IN" }, { "Interlingua", "IA" }, {
					"Interlingue", "IE" }, { "Inupiak", "IK" }, {
							"Irish", "GA" }, { "Italian", "IT" }, {
									"Japanese", "JA" }, { "Javanese",
											"JW" }, { "Kannada", "KN" },
			{ "Kashmiri", "KS" }, { "Kazakh", "KK" }, { "Kinyarwanda",
					"RW" }, { "Kirghiz", "KY" }, { "Kirundi", "RN" }, {
							"Korean", "KO" }, { "Kurdish", "KU" }, {
									"Laothian", "LO" }, { "Latin",
											"LA" }, { "Latvian,Lettish",
													"LV" }, { "Lingala",
															"LN,Lettish" },
			{ "Lithuanian", "LT" }, { "Macedonian", "MK" }, {
					"Malagasy", "MG" }, { "Malay", "MS" }, {
							"Malayalam", "ML" }, { "Maltese", "MT" }, {
									"Maori", "MI" }, { "Marathi",
											"MR" }, { "Moldavian",
													"MO" }, {
															"Mongolian",
															"MN" }, {
																	"Nauru",
																	"NA" },
			{ "Nepali", "NE" }, { "Norwegian", "NO" }, { "Occitan",
					"OC" }, { "Oriya", "OR" }, { "Oromo,Afan",
							"OM,Afan" }, { "Pashto,Pushto", "PS" }, {
									"Persian", "FA" }, { "Polish",
											"PL" }, { "Portuguese",
													"PT,Pushto" }, {
															"Punjabi",
															"PA" }, {
																	"Quechua",
																	"QU" },
			{ "Rhaeto-Romance", "RM-Romance" }, { "Romanian", "RO" }, {
					"Russian", "RU" }, { "Samoan", "SM" }, { "Sangro",
							"SG" }, { "Sanskrit", "SA" }, { "Serbian",
									"SR" }, { "Serbo-Croatian", "SH" },
			{ "Sesotho", "ST-Croatian" }, { "Setswana", "TN" }, {
					"Shona", "SN" }, { "Sindhi", "SD" }, { "Singhalese",
							"SI" }, { "Siswati", "SS" }, { "Slovak",
									"SK" }, { "Slovenian", "SL" }, {
											"Somali", "SO" }, {
													"Spanish", "ES" }, {
															"Sudanese",
															"SU" }, {
																	"Swahili",
																	"SW" },
			{ "Swedish", "SV" }, { "Tagalog", "TL" }, { "Tajik", "TG" },
			{ "Tamil", "TA" }, { "Tatar", "TT" }, { "Tegulu", "TE" }, {
					"Thai", "TH" }, { "Tibetan", "BO" }, { "Tigrinya",
							"TI" }, { "Tonga", "TO" }, { "Tsonga",
									"TS" }, { "Turkish", "TR" }, {
											"Turkmen", "TK" }, { "Twi",
													"TW" }, {
															"Ukrainian",
															"UK" }, {
																	"Urdu",
																	"UR" },
			{ "Uzbek", "UZ" }, { "Vietnamese", "VI" }, { "Volapuk",
					"VO" }, { "Welsh", "CY" }, { "Wolof", "WO" }, {
							"Xhosa", "XH" }, { "Yiddish", "JI" }, {
									"Yoruba", "YO" }, { "Zulu",
											"ZU" } };

	/** list of valid colors for CSS */
	public final static String[] cssColorE = { "Black", "Navy",
			"DarkBlue", "MediumBlue", "Blue", "DarkGreen", "Green",
			"Teal", "DarkCyan", "DeepSkyBlue", "DarkTurquoise",
			"MediumSpringGreen", "Lime", "SpringGreen", "Aqua", "Cyan",
			"MidnightBlue", "DodgerBlue", "LightSeaGreen",
			"ForestGreen", "SeaGreen", "DarkSlateGray", "LimeGreen",
			"MediumSeaGreen", "Turquoise", "RoyalBlue", "SteelBlue",
			"DarkSlateBlue", "MediumTurquoise", "Indigo",
			"DarkOliveGreen", "CadetBlue", "CornflowerBlue",
			"RebeccaPurple", "MediumAquaMarine", "DimGray", "SlateBlue",
			"OliveDrab", "SlateGray", "LightSlateGray",
			"MediumSlateBlue", "LawnGreen", "Chartreuse", "Aquamarine",
			"Maroon", "Purple", "Olive", "Gray", "SkyBlue",
			"LightSkyBlue", "BlueViolet", "DarkRed", "DarkMagenta",
			"SaddleBrown", "DarkSeaGreen", "LightGreen", "MediumPurple",
			"DarkViolet", "PaleGreen", "DarkOrchid", "YellowGreen",
			"Sienna", "Brown", "DarkGray", "LightBlue", "GreenYellow",
			"PaleTurquoise", "LightSteelBlue", "PowderBlue",
			"FireBrick", "DarkGoldenRod", "MediumOrchid", "RosyBrown",
			"DarkKhaki", "Silver", "MediumVioletRed", "IndianRed",
			"Peru", "Chocolate", "Tan", "LightGray", "Thistle",
			"Orchid", "GoldenRod", "PaleVioletRed", "Crimson",
			"Gainsboro", "Plum", "BurlyWood", "LightCyan", "Lavender",
			"DarkSalmon", "Violet", "PaleGoldenRod", "LightCoral",
			"Khaki", "AliceBlue", "HoneyDew", "Azure", "SandyBrown",
			"Wheat", "Beige", "WhiteSmoke", "MintCream", "GhostWhite",
			"Salmon", "AntiqueWhite", "Linen", "LightGoldenRodYellow",
			"OldLace", "Red", "Fuchsia", "Magenta", "DeepPink",
			"OrangeRed", "Tomato", "HotPink", "Coral", "DarkOrange",
			"LightSalmon", "Orange", "LightPink", "Pink", "Gold",
			"PeachPuff", "NavajoWhite", "Moccasin", "Bisque",
			"MistyRose", "BlanchedAlmond", "PapayaWhip",
			"LavenderBlush", "SeaShell", "Cornsilk", "LemonChiffon",
			"FloralWhite", "Snow", "Permission", "LightYellow", "Ivory",
			"White" };
}
